﻿using System;
using System.Collections.Generic;
using Volo.Abp.Application.Dtos;

namespace Sanhe.Abp.Auditing.AuditLogs
{
    public class AuditLogDto : ExtensibleEntityDto<Guid>
    {
        /// <summary>
        /// 应用名称
        /// </summary>
        public string ApplicationName { get; set; }
        /// <summary>
        /// 用户Id
        /// </summary>
        public Guid? UserId { get; set; }
        /// <summary>
        /// 用户名称
        /// </summary>
        public string UserName { get; set; }
        /// <summary>
        /// 租户Id
        /// </summary>
        public Guid? TenantId { get; set; }
        /// <summary>
        /// 租户名称
        /// </summary>
        public string TenantName { get; set; }
        /// <summary>
        /// 模拟用户Id
        /// </summary>
        public Guid? ImpersonatorUserId { get; set; }
        /// <summary>
        /// 模拟租户Id
        /// </summary>
        public Guid? ImpersonatorTenantId { get; set; }
        /// <summary>
        /// 调用时间
        /// </summary>
        public DateTime ExecutionTime { get; set; }
        /// <summary>
        /// 响应时间(ms)
        /// </summary>
        public int ExecutionDuration { get; set; }
        /// <summary>
        /// 客户端Ip地址
        /// </summary>
        public string ClientIpAddress { get; set; }
        /// <summary>
        /// 客户端名称
        /// </summary>
        public string ClientName { get; set; }
        /// <summary>
        /// 客户端Id
        /// </summary>
        public string ClientId { get; set; }
        /// <summary>
        /// 链路标识
        /// </summary>
        public string CorrelationId { get; set; }
        /// <summary>
        /// 浏览器信息
        /// </summary>
        public string BrowserInfo { get; set; }
        /// <summary>
        /// Http方法
        /// </summary>
        public string HttpMethod { get; set; }
        /// <summary>
        /// Url
        /// </summary>
        public string Url { get; set; }
        /// <summary>
        /// 异常
        /// </summary>
        public string Exceptions { get; set; }
        /// <summary>
        /// 评论
        /// </summary>
        public string Comments { get; set; }
        /// <summary>
        /// Http状态码
        /// </summary>
        public int? HttpStatusCode { get; set; }
        /// <summary>
        /// 实体变更
        /// </summary>
        public List<EntityChangeDto> EntityChanges { get; set; }
        public List<AuditLogActionDto> Actions { get; set; }

        public AuditLogDto()
        {
            EntityChanges = new List<EntityChangeDto>();
            Actions = new List<AuditLogActionDto>();
        }
    }
}
