﻿using System;
using System.Net;
using Volo.Abp.Application.Dtos;

namespace Sanhe.Abp.Auditing.AuditLogs
{
    public class AuditLogGetByPagedDto : PagedAndSortedResultRequestDto
    {
        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime? StartTime { get; set; }
        /// <summary>
        /// 结束时间
        /// </summary>
        public DateTime? EndTime { get; set; }
        /// <summary>
        /// 请求方法
        /// </summary>
        public string HttpMethod { get; set; }
        /// <summary>
        /// Url
        /// </summary>
        public string Url { get; set; }
        /// <summary>
        /// 用户Id
        /// </summary>
        public Guid? UserId { get; set; }
        /// <summary>
        /// 用户名称
        /// </summary>
        public string UserName { get; set; }
        /// <summary>
        /// 应用名称
        /// </summary>
        public string ApplicationName { get; set; }
        /// <summary>
        /// 链路标识
        /// </summary>
        public string CorrelationId { get; set; }
        /// <summary>
        /// 客户端Id
        /// </summary>
        public string ClientId { get; set; }
        /// <summary>
        /// 客户端Ip地址
        /// </summary>
        public string ClientIpAddress { get; set; }
        /// <summary>
        /// 最长响应时间(ms)
        /// </summary>
        public int? MaxExecutionDuration { get; set; }
        /// <summary>
        /// 最短响应时间(ms)
        /// </summary>
        public int? MinExecutionDuration { get; set; }
        /// <summary>
        /// 包含异常
        /// </summary>
        public bool? HasException { get; set; }
        /// <summary>
        /// Http状态码
        /// </summary>
        public HttpStatusCode? HttpStatusCode { get; set; }
    }
}
