﻿using System;
using System.Collections.Generic;
using Volo.Abp.Application.Dtos;
using Volo.Abp.Auditing;

namespace Sanhe.Abp.Auditing.AuditLogs
{
    public class EntityChangeDto : ExtensibleEntityDto<Guid>
    {
        /// <summary>
        /// 变更时间
        /// </summary>
        public DateTime ChangeTime { get; set; }
        /// <summary>
        /// 变更类型
        /// </summary>
        public EntityChangeType ChangeType { get; set; }
        /// <summary>
        /// 实体租户Id
        /// </summary>
        public Guid? EntityTenantId { get; set; }
        /// <summary>
        /// 实体标识
        /// </summary>
        public string EntityId { get; set; }
        /// <summary>
        /// 实体类型
        /// </summary>
        public string EntityTypeFullName { get; set; }
        /// <summary>
        /// 属性变更
        /// </summary>
        public List<EntityPropertyChangeDto> PropertyChanges { get; set; }

        public EntityChangeDto()
        {
            PropertyChanges = new List<EntityPropertyChangeDto>();
        }
    }
}
