﻿using Microsoft.Extensions.Logging;
using System;
using Volo.Abp.Application.Dtos;

namespace Sanhe.Abp.Auditing.Logging
{
    public class LogGetByPagedDto : PagedAndSortedResultRequestDto
    {
        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime? StartTime { get; set; }
        /// <summary>
        /// 结束时间
        /// </summary>
        public DateTime? EndTime { get; set; }
        /// <summary>
        /// 日志等级
        /// </summary>
        public LogLevel? Level { get; set; }
        /// <summary>
        /// 机器名称
        /// </summary>
        public string MachineName { get; set; }
        /// <summary>
        /// 应用环境
        /// </summary>
        public string Environment { get; set; }
        /// <summary>
        /// 应用信息
        /// </summary>
        public string Application { get; set; }
        /// <summary>
        /// 上下文
        /// </summary>
        public string Context { get; set; }
        /// <summary>
        /// 请求标识
        /// </summary>
        public string RequestId { get; set; }
        /// <summary>
        /// 请求路径
        /// </summary>
        public string RequestPath { get; set; }
        /// <summary>
        /// 链路标识
        /// </summary>
        public string CorrelationId { get; set; }
        /// <summary>
        /// 进程标识
        /// </summary>
        public int? ProcessId { get; set; }
        /// <summary>
        /// 线程标识
        /// </summary>
        public int? ThreadId { get; set; }
        /// <summary>
        /// 包含异常
        /// </summary>
        public bool? HasException { get; set; }
    }
}
