﻿using AutoMapper;
using Sanhe.Abp.Auditing.AuditLogs;
using Sanhe.Abp.Auditing.Logging;
using Sanhe.Abp.Auditing.SecurityLogs;
using Sanhe.Abp.AuditLogging;
using Sanhe.Abp.Logging;

namespace Sanhe.Abp.Auditing
{
    public class AbpAuditingMapperProfile : Profile
    {
        public AbpAuditingMapperProfile()
        {
            CreateMap<AuditLogAction, AuditLogActionDto>()
                .MapExtraProperties();
            CreateMap<EntityPropertyChange, EntityPropertyChangeDto>();
            CreateMap<EntityChangeWithUsername, EntityChangeWithUsernameDto>();
            CreateMap<EntityChange, EntityChangeDto>()
                .MapExtraProperties();
            CreateMap<AuditLog, AuditLogDto>()
                .MapExtraProperties();

            CreateMap<SecurityLog, SecurityLogDto>()
                .MapExtraProperties();

            CreateMap<LogField, LogFieldDto>();
            CreateMap<LogException, LogExceptionDto>();
            CreateMap<LogInfo, LogDto>();
        }
    }
}
