﻿using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;
using Volo.Abp;
using Volo.Abp.Application.Dtos;
using Volo.Abp.AspNetCore.Mvc;

namespace Sanhe.Abp.Auditing.Logging;

/// <summary>
/// 日志
/// </summary>
[RemoteService(Name = AuditingRemoteServiceConsts.RemoteServiceName)]
[Area("auditing")]
[Route("api/auditing/logging")]
public class LogController : AbpController, ILogAppService
{
    private readonly ILogAppService _service;

    public LogController(ILogAppService service)
    {
        _service = service;
    }

    /// <summary>
    /// 根据Id获取
    /// </summary>
    /// <param name="id"></param>
    /// <returns></returns>
    [HttpGet]
    [Route("{id}")]
    public virtual Task<LogDto> GetAsync(string id)
    {
        return _service.GetAsync(id);
    }

    /// <summary>
    /// 分页获取
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    [HttpGet]
    public virtual Task<PagedResultDto<LogDto>> GetListAsync(LogGetByPagedDto input)
    {
        return _service.GetListAsync(input);
    }
}
