﻿using Sanhe.Abp.Hangfire.Dashboard.Localization;
using Volo.Abp.Authorization.Permissions;
using Volo.Abp.Localization;
using Volo.Abp.MultiTenancy;

namespace Sanhe.Abp.Hangfire.Dashboard.Permissions;

public class HangfireDashboardPermissionsDefinitionProvider : PermissionDefinitionProvider
{
    public override void Define(IPermissionDefinitionContext context)
    {
        var group = context.AddGroup(
            name: HangfireDashboardPermissions.Hangfire,
            displayName: L("Permission:Hangfire"),
            MultiTenancySides.Host);

        group.AddPermission(HangfireDashboardPermissions.Dashboard, L("Permission:Dashboard"));
    }

    private static LocalizableString L(string name)
    {
        return LocalizableString.Create<HangfireDashboardResource>(name);
    }
}
