﻿using System.Collections.Generic;
using Volo.Abp.Localization;

namespace Sanhe.Abp.Localization.Dynamic;

public class AbpLocalizationDynamicOptions
{
    internal LocalizationDictionary LocalizationDictionary { get; }

    public AbpLocalizationDynamicOptions()
    {
        LocalizationDictionary = new LocalizationDictionary();
    }

    internal void AddOrUpdate(string resourceName, Dictionary<string, ILocalizationDictionary> dictionaries)
    {
        var currentDictionaries = LocalizationDictionary
            .GetOrAdd(resourceName, () => new Dictionary<string, ILocalizationDictionary>());

        currentDictionaries.AddIfNotContains(dictionaries);
    }
}
