﻿using JetBrains.Annotations;
using Volo.Abp.Localization;

namespace Sanhe.Abp.Notifications;

/// <summary>
/// 通知定义上下文
/// </summary>
public interface INotificationDefinitionContext
{
    /// <summary>
    /// 添加通知组定义
    /// </summary>
    /// <param name="name"></param>
    /// <param name="displayName"></param>
    /// <param name="allowSubscriptionToClients"></param>
    /// <returns></returns>
    NotificationGroupDefinition AddGroup(
        [NotNull] string name,
        ILocalizableString displayName = null,
        bool allowSubscriptionToClients = true);
    /// <summary>
    /// 获取通知组定义
    /// </summary>
    /// <param name="name"></param>
    /// <returns></returns>
    NotificationGroupDefinition GetGroupOrNull(string name);
    /// <summary>
    /// 移除通知组
    /// </summary>
    /// <param name="name"></param>
    void RemoveGroup(string name);
}
