﻿using JetBrains.Annotations;
using System.Collections.Generic;

namespace Sanhe.Abp.Notifications;

/// <summary>
/// 通知定义管理者接口
/// </summary>
public interface INotificationDefinitionManager
{
    /// <summary>
    /// 获取通知定义
    /// </summary>
    /// <param name="name"></param>
    /// <returns></returns>
    [NotNull]
    NotificationDefinition Get([NotNull] string name);
    /// <summary>
    /// 获取所有通知定义
    /// </summary>
    /// <returns></returns>
    IReadOnlyList<NotificationDefinition> GetAll();
    /// <summary>
    /// 获取通知定义，如果为空返回Null
    /// </summary>
    /// <param name="name"></param>
    /// <returns></returns>
    NotificationDefinition GetOrNull(string name);
    /// <summary>
    /// 获取通知定义分组列表
    /// </summary>
    /// <returns></returns>
    IReadOnlyList<NotificationGroupDefinition> GetGroups();
}
