﻿using System.Threading;
using System.Threading.Tasks;

namespace Sanhe.Abp.Identity
{
    public interface IUserSecurityCodeSender
    {
        /// <summary>
        /// 发送手机确认码
        /// </summary>
        /// <param name="phone">手机号</param>
        /// <param name="token">令牌</param>
        /// <param name="template">模板号</param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task SendPhoneConfirmedCodeAsync(
            string phone,
            string token,
            string template, // 传递模板号
            CancellationToken cancellation = default);

        /// <summary>
        /// 发送邮箱确认码
        /// </summary>
        /// <param name="userName">用户名</param>
        /// <param name="email">邮箱</param>
        /// <param name="token">令牌</param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task SendEmailConfirmedCodeAsync(
            string userName,
            string email,
            string token,
            CancellationToken cancellation = default);
    }
}
