﻿namespace Sanhe.Abp.Identity.Security
{
    /// <summary>
    /// totp算法服务
    /// </summary>
    public interface ITotpService
    {
        /// <summary>
        /// 生成
        /// </summary>
        /// <param name="securityToken"></param>
        /// <param name="modifier"></param>
        /// <returns></returns>
        int GenerateCode(byte[] securityToken, string modifier = null);

        /// <summary>
        /// 验证
        /// </summary>
        /// <param name="securityToken"></param>
        /// <param name="code"></param>
        /// <param name="modifier"></param>
        /// <returns></returns>
        bool ValidateCode(byte[] securityToken, int code, string modifier = null);
    }
}
