﻿using System.ComponentModel.DataAnnotations;
using Volo.Abp.Validation;

namespace Sanhe.Abp.LocalizationManagement;

public class CreateOrUpdateLanguageInput
{
    public virtual bool Enable { get; set; }

    [Required]
    [DynamicStringLength(typeof(LanguageConsts), nameof(LanguageConsts.MaxCultureNameLength))]
    public string CultureName { get; set; }

    [Required]
    [DynamicStringLength(typeof(LanguageConsts), nameof(LanguageConsts.MaxUiCultureNameLength))]
    public string UiCultureName { get; set; }

    [Required]
    [DynamicStringLength(typeof(LanguageConsts), nameof(LanguageConsts.MaxDisplayNameLength))]
    public string DisplayName { get; set; }

    [DynamicStringLength(typeof(LanguageConsts), nameof(LanguageConsts.MaxFlagIconLength))]
    public string FlagIcon { get; set; }
}
