﻿using Microsoft.Extensions.DependencyInjection;
using Volo.Abp.Application;
using Volo.Abp.AutoMapper;
using Volo.Abp.Modularity;

namespace Sanhe.Abp.LocalizationManagement;

[DependsOn(
    typeof(AbpDddApplicationModule),
    typeof(AbpLocalizationManagementDomainModule),
    typeof(AbpLocalizationManagementApplicationContractsModule))]
public class AbpLocalizationManagementApplicationModule : AbpModule
{
    public override void ConfigureServices(ServiceConfigurationContext context)
    {
        context.Services.AddAutoMapperObjectMapper<AbpLocalizationManagementApplicationModule>();

        Configure<AbpAutoMapperOptions>(options =>
        {
            options.AddProfile<LocalizationManagementApplicationMapperProfile>(validate: true);
        });
    }
}
