﻿using Microsoft.Extensions.DependencyInjection;
using Sanhe.Abp.Localization.Dynamic;
using Sanhe.Abp.LocalizationManagement.Localization;
using Volo.Abp.AutoMapper;
using Volo.Abp.Domain;
using Volo.Abp.Localization;
using Volo.Abp.Modularity;

namespace Sanhe.Abp.LocalizationManagement;

[DependsOn(
    typeof(AbpAutoMapperModule),
    typeof(AbpDddDomainModule),
    typeof(AbpLocalizationDynamicModule),
    typeof(AbpLocalizationManagementDomainSharedModule))]
public class AbpLocalizationManagementDomainModule : AbpModule
{
    public override void ConfigureServices(ServiceConfigurationContext context)
    {
        context.Services.AddAutoMapperObjectMapper<AbpLocalizationManagementDomainModule>();

        Configure<AbpLocalizationOptions>(options =>
        {
            options.Resources
                .Get<LocalizationManagementResource>()
                .AddDynamic();
        });

        Configure<AbpAutoMapperOptions>(options =>
        {
            options.AddProfile<LocalizationManagementDomainMapperProfile>(validate: true);
        });

        // 分布式事件
        //Configure<AbpDistributedEntityEventOptions>(options =>
        //{
        //    options.AutoEventSelectors.Add<Text>();
        //    options.EtoMappings.Add<Text, TextEto>();
        //});
    }
}
