﻿using Microsoft.Extensions.DependencyInjection;
using Sanhe.Abp.IdGenerator;
using Sanhe.Abp.IdGenerator.Snowflake;
using Volo.Abp.Modularity;

namespace Sanhe.Abp.Serilog.Enrichers.UniqueId
{
    [DependsOn(typeof(AbpIdGeneratorModule))]
    public class AbpSerilogEnrichersUniqueIdModule : AbpModule
    {
        public override void ConfigureServices(ServiceConfigurationContext context)
        {
            var options = context.Services.ExecutePreConfiguredActions<AbpSerilogEnrichersUniqueIdOptions>();
            UniqueIdEnricher.DistributedIdGenerator = SnowflakeIdGenerator.Create(options.SnowflakeIdOptions);
        }
    }
}
