﻿using System;
using System.Collections.Generic;
using Volo.Abp.Application.Dtos;
using Volo.Abp.MultiTenancy;

namespace Sanhe.Abp.MenuManagement
{
    public class MenuDto : AuditedEntityDto<Guid>
    {
        /// <summary>
        /// 名称
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 显示名称
        /// </summary>
        public string DisplayName { get; set; }
        /// <summary>
        /// 菜单类型
        /// </summary>
        public MenuEnumType MenuType { get; set; }
        /// <summary>
        /// 组件路径
        /// </summary>
        public string ComponentPath { get; set; }
        /// <summary>
        /// 路由路径
        /// </summary>
        public string RouterPath { get; set; }
        /// <summary>
        /// 父级显示名称
        /// </summary>
        public string ParentDisplayName { get; set; }
        /// <summary>
        /// 父Id
        /// </summary>
        public Guid? ParentId { get; set; }
        /// <summary>
        /// 图标
        /// </summary>
        public string Icon { get; set; }
        /// <summary>
        /// 排序
        /// </summary>
        public string Sort { get; set; }
        /// <summary>
        /// window.open _blank 
        /// </summary>
        public string TargetUrl { get; set; }
        /// <summary>
        /// 此菜单关联的权限key
        /// </summary>
        public string PermissionKey { get; set; }
        /// <summary>
        /// 表示多租户应用程序中的所属方
        /// </summary>
        public MultiTenancySides MultiTenancySide { get; set; }
        /// <summary>
        /// 子菜单
        /// </summary>
        public List<MenuDto> Children { get; set; } = new List<MenuDto>();
    }
}
