﻿using AutoMapper;

namespace Sanhe.Abp.MenuManagement;

public class MenuManagementApplicationAutoMapperProfile : Profile
{
    public MenuManagementApplicationAutoMapperProfile()
    {
        CreateMap<Menu, MenuDto>();
        CreateMap<CreateOrUpdateMenuDto, Menu>();
        CreateMap<Menu, FrontMenu>()
            .ForMember(d => d.Component, opt => { opt.MapFrom(s => s.ComponentPath); })
            .ForMember(d => d.Path, opt => { opt.MapFrom(s => s.RouterPath); })
            .ForMember(d => d.Meta,
                opt =>
                {
                    opt.MapFrom(s => new MenuMeta
                    {
                        Icon = s.Icon,
                        Title = s.DisplayName
                    });
                });
    }
}
