﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;
using Volo.Abp.Domain.Repositories;

namespace Sanhe.Abp.MenuManagement
{
    public interface IMenuGrantRepository : IBasicRepository<MenuGrant, Guid>
    {
        Task<MenuGrant> FindAsync(Guid menuId,
            string providerName,
            string providerKey,
            CancellationToken cancellationToken = default);

        Task<List<MenuGrant>> GetListAsync(
            string providerName,
            string providerKey,
            CancellationToken cancellationToken = default
        );

        Task<List<MenuGrant>> GetGrantByMenuIdAsync(Guid menuId, bool noTracking = true);
    }
}
