﻿using JetBrains.Annotations;
using System;
using System.Threading.Tasks;
using Volo.Abp.DependencyInjection;

namespace Sanhe.Abp.MenuManagement
{
    public interface IMenuManagementProvider : ITransientDependency
    {
        string Name { get; }

        Task<MenuGrantInfo> CheckAsync(
            [NotNull] Guid menuId,
            [NotNull] string providerName,
            [NotNull] string providerKey
        );

        Task SetAsync(
            [NotNull] Guid menuId,
            [NotNull] string providerKey,
            bool isGranted
        );
    }

}
