﻿using Microsoft.Extensions.DependencyInjection;
using Volo.Abp.EntityFrameworkCore;
using Volo.Abp.Modularity;
using Volo.Abp.PermissionManagement.EntityFrameworkCore;

namespace Sanhe.Abp.MenuManagement.EntityFrameworkCore;

[DependsOn(
    typeof(AbpPermissionManagementEntityFrameworkCoreModule),
    typeof(MenuManagementDomainModule),
    typeof(AbpEntityFrameworkCoreModule)
)]
public class MenuManagementEntityFrameworkCoreModule : AbpModule
{
    public override void ConfigureServices(ServiceConfigurationContext context)
    {
        context.Services.AddAbpDbContext<MenuManagementDbContext>(options =>
        {
            options.AddRepository<Menu, MenuRepository>();
        });
    }
}
