﻿using Microsoft.EntityFrameworkCore;
using Sanhe.Abp.MenuManagement.EntityFrameworkCore;
using System;
using System.Linq;
using System.Threading.Tasks;
using Volo.Abp.Domain.Repositories.EntityFrameworkCore;
using Volo.Abp.EntityFrameworkCore;

namespace Sanhe.Abp.MenuManagement
{
    public class MenuRepository : EfCoreRepository<IMenuManagementDbContext, Menu, Guid>, IMenuRepository
    {
        public MenuRepository(IDbContextProvider<IMenuManagementDbContext> dbContextProvider) : base(dbContextProvider)
        {

        }

        public override async Task<IQueryable<Menu>> WithDetailsAsync()
        {
            var queryable = await GetQueryableAsync();

            return queryable.Include(x => x.Parent);
        }
    }
}
