﻿using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;
using Volo.Abp;

namespace Sanhe.Abp.MenuManagement
{
    /// <summary>
    /// 菜单分配
    /// </summary>
    [RemoteService]
    [Route("api/menu-management/menu-grant")]
    public class MenuGrantController : MenuManagementController, IMenuGrantAppService
    {
        private readonly IMenuGrantAppService _menuGrantAppService;

        public MenuGrantController(IMenuGrantAppService menuGrantAppService)
        {
            _menuGrantAppService = menuGrantAppService;
        }

        [HttpGet("list")]
        public virtual Task<GetMenuResultDto> GetListAsync()
        {
            return _menuGrantAppService.GetListAsync();
        }

        [HttpGet]
        public virtual Task<GetMenuGrantListResultDto> GetAsync(string providerName, string providerKey)
        {
            return _menuGrantAppService.GetAsync(providerName, providerKey);
        }

        [HttpPut]
        public virtual Task UpdateAsync(string providerName, string providerKey, UpdateMenuGrantsDto input)
        {
            return _menuGrantAppService.UpdateAsync(providerName, providerKey, input);
        }
    }
}
