. ".\common.ps1"

# 重新构建所有解决方案
foreach($solution in $solutions) {
    $solutionFolder = Join-Path $rootFolder $solution
    Set-Location $solutionFolder
    & dotnet restore
}

# 删除旧的Nuget包
del *.nupkg

# 创建新的Nuget包
$i = 0
$projectsCount = $projects.length
Write-Info "Running dotnet pack on $projectsCount projects..."

foreach($project in $projects) {
    $i += 1
    $projectFolder = Join-Path $rootFolder $project
	$projectName = ($project -split '/')[-1]
	
    # 创建Nuget包
    Write-Info "[$i / $projectsCount] - Packing project: $projectName"
	Set-Location $projectFolder
    dotnet clean
    dotnet pack -c Release

    if (-Not $?) {
        Write-Error "Packaging failed for the project: $projectName" 
        exit $LASTEXITCODE
    }
    
    # 移动Nuget包
    $projectName = $project.Substring($project.LastIndexOf("/") + 1)
    $projectPackPath = Join-Path $projectFolder ("/bin/Release/" + $projectName + ".*.nupkg")
    Move-Item -Force $projectPackPath $packFolder
	
	Seperator
}

# 退回Nuget包文件夹
Set-Location $packFolder